(function(window, document, undefined){
	var instance;
	if (typeof define == 'function') {
		define('og', ['xmls','lc', 'vr'],
			function(xmls, locale, vars){		
				return new origin(xmls, locale, vars);
		});
	}
	else {
		window.origin = new origin(
			window.xmls,
			window.locale,
      window.vars
		);
	}
	function origin(xmls, locale, vars){if(instance) return instance;
		var origins = {};
		data = $(xmls[0]);
		
		Object.defineProperty(origins, 'level', {
			enumerable: false,
			writable: false,
			value: function(num, origins_array, callback, error){
				var notOrigin = origins_array[0] == '!',
					isInArray = !!~origins_array.indexOf(origins[num].type),
					allowedOrigin = notOrigin ? !isInArray : isInArray;
					
				allowedOrigin ? callback && callback()
							  : error && errorr();
							  
				return allowedOrigin;
			}
		})
		
		origins[0] = {
			type: exports.origin || vars.device || 'NULL',
			subtype: data.attr('prm_subtype') || 'NULL',
			name: data.attr('desc') || locale('param.proc.0')
		};
		
		origins.level(0, ['TM3COM'], function(){
			data.find('Coprocessor > Config').each(function(i,e){
				var $e = $(e);
				var num = $e.attr('sport');
				origins[num] = {
					type: $e.attr('prm_type') || 'NULL',
					subtype: $e.attr('prm_subtype') || 'NULL',
					name: $e.attr('desc')
				};
			});
		});			
		return instance = origins;
	}
})(window, document, undefined);

